bugboard/urls.py
# Third party
from django.urls import path

# Local application / specific library imports
from . import views


urlpatterns = [
    path("", views.UnnassignedView.as_view(), name="unnassigned"),
    path("unnassigned/", views.UnnassignedView.as_view(), name="unnassigned"),
    path("user/", views.ByMemberView.as_view(), name="user"),
    path("commented/", views.CommentedView.as_view(), name="commented"),
    path("created/", views.CreatedView.as_view(), name="created"),
    path("all/", views.AllView.as_view(), name="all"),
    # api ?
    path("update/task/<int:id_task>", views.update_task),
]

website/urls.py
import os

# Third party
from django.contrib import admin
from django.urls import include, path


urlpatterns = [
    path("", include("bugboard.urls")),
    path(os.environ["ADMIN_URL"] + "/", admin.site.urls),
    path("bugboard/", include("bugboard.urls")),
]

bugboard/models.py
# Third party
from django.db import models


class Member(models.Model):
    """Member structure that allow storing data returned by BugHerd api.

    Arguments:
        models {django.db.models.Model} -- Default django model.
    """

    id_member = models.IntegerField(primary_key=True)
    email = models.EmailField(max_length=254, null=True)
    display_name = models.CharField(max_length=255)
    avatar_url = models.URLField(
        max_length=255, default="https://i.imgur.com/1c85UxD.png"
    )
    member = models.BooleanField()

    def __str__(self):
        return self.email


class Project(models.Model):
    """Project structure that allow storing data returned by BugHerd api.

    Arguments:
        models {django.db.models.Model} -- Default django model.
    """

    id_project = models.IntegerField(primary_key=True)
    name = models.CharField(max_length=255)
    devurl = models.URLField(max_length=255, null=True)
    api_key = models.CharField(max_length=255, null=True)
    is_active = models.BooleanField(null=True)


class Task(models.Model):
    """Task structure that allow storing data returned by BugHerd api.

    Arguments:
        models {django.db.models.Model} -- Default django model.
    """

    id_task = models.IntegerField(primary_key=True)
    project = models.ForeignKey(Project, on_delete=models.CASCADE)
    created_at = models.DateTimeField()
    updated_at = models.DateTimeField(null=True)
    local_task_id = models.IntegerField(null=True)
    priority_id = models.IntegerField(null=True)
    priority = models.CharField(max_length=255, null=True)
    status = models.CharField(max_length=255, null=True)
    description = models.TextField(null=True)
    external_id = models.IntegerField(null=True)
    requester_id = models.IntegerField(null=True)
    requester_email = models.EmailField(max_length=255, null=True)
    due_at = models.DateTimeField(null=True)
    admin_link = models.URLField(max_length=255, default="#", null=True)
    assignee = models.ManyToManyField("Member")
    tag = models.ManyToManyField("Tag")
    comment = models.ManyToManyField("Comment")


class Tag(models.Model):
    """Tag structure that allow storing data returned by BugHerd api.

    Arguments:
        models {django.db.models.Model} -- Default django model.
    """

    name = models.CharField(max_length=255)


class Comment(models.Model):
    """Comments structure that allow storing data returned by BugHerd api.

    Arguments:
        models {django.db.models.Model} -- Default django model.
    """

    id_comment = models.IntegerField(primary_key=True)
    created_at = models.DateTimeField()
    text = models.TextField(null=True)
    member = models.ForeignKey(Member, on_delete=models.CASCADE, null=True)

bugboard/views.py
# Standard Library
import traceback

# Django
from django.core import management
from django.db.models import Max, OuterRef, Subquery
from django.http import JsonResponse
from django.template.loader import render_to_string
from django.views import generic

# Project
from bugboard.models import Comment, Project, Task


class UnnassignedView(generic.ListView):
    template_name = "bugboard/base.html"
    paginate_by = 100

    def get_ordering(self):
        return self.request.GET.get("order", "-created_at")

    def get_queryset(self):
        # ordering is called inside this function, so call it here
        ordering = self.get_ordering()

        # Thanks https://docs.djangoproject.com/fr/2.2/ref/models/expressions/#subquery-expressions
        newest = Comment.objects.filter(task=OuterRef("pk")).order_by("-created_at")

        # return assigned tasks, without "done" tasks without comments or "done" tasks with last comment from a member
        return (
            Task.objects.filter(assignee=None)
            .exclude(
                status__in=["done", "Terminé"], comment=None
            )  # exclude if status is "Done/Terminé" and task have no comment
            .annotate(
                last_com=Subquery(newest.values("member__member")[:1])
            )  # add last com in queryset
            .exclude(
                status__in=["done", "Terminé"], last_com=True
            )  # exclude if status is "Done/Terminé" and last comment is from a member (and not a guest)
            .order_by(ordering)
        )

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["total_tasks"] = Task.objects.all().count()
        context["total_projects"] = Project.objects.all().count()
        return context


class ByMemberView(generic.ListView):
    template_name = "bugboard/base.html"
    paginate_by = 100

    def get_ordering(self):
        return self.request.GET.get("order", "-created_at")

    def get_queryset(self):
        # ordering is called inside this function, so call it here
        ordering = self.get_ordering()

        # Thanks https://docs.djangoproject.com/fr/2.2/ref/models/expressions/#subquery-expressions
        newest = Comment.objects.filter(task=OuterRef("pk")).order_by("-created_at")

        # return assigned tasks, without "done" tasks without comments or "done" tasks with last comment from a member
        return (
            Task.objects.filter(assignee__id_member=self.request.GET.get("id", None))
            .exclude(
                status__in=["done", "Terminé"], comment=None
            )  # exclude if status is "Done" and task have no comment
            .annotate(
                last_com=Subquery(newest.values("member__member")[:1])
            )  # add last com in queryset
            .exclude(
                status__in=["done", "Terminé"], last_com=True
            )  # exclude if status is "Done" ans last comment is from a member (and not a guest)
            .order_by(ordering)
        )

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["total_tasks"] = Task.objects.all().count()
        context["total_projects"] = Project.objects.all().count()
        return context


class CommentedView(generic.ListView):
    template_name = "bugboard/base.html"
    paginate_by = 100

    # Thanks https://docs.djangoproject.com/fr/2.2/ref/models/expressions/#subquery-expressions
    newest = Comment.objects.filter(task=OuterRef("pk")).order_by("-created_at")

    queryset = (
        Task.objects.exclude(comment=None)  # exclude tasks with no comments
        .annotate(last_com=Max("comment__created_at"))  # add last com in queryset
        .annotate(
            last_comment_member=Subquery(newest.values("member__member")[:1])
        )  # add last com status
        .exclude(
            last_comment_member=True
        )  # exclude comments from team members (status var)
        .order_by("-last_com")  # order by last com first
    )

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["total_tasks"] = Task.objects.all().count()
        context["total_projects"] = Project.objects.all().count()
        return context


class CreatedView(generic.ListView):
    template_name = "bugboard/base.html"
    queryset = Task.objects.all()
    paginate_by = 100

    # set ordering based on the ?order=PARAM parameter, set -created_at if there is no get
    def get_ordering(self):
        return self.request.GET.get("order", "-created_at")

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["total_tasks"] = Task.objects.all().count()
        context["total_projects"] = Project.objects.all().count()
        return context


class AllView(generic.ListView):
    template_name = "bugboard/base.html"
    queryset = Task.objects.all()

    def get_ordering(self):
        return self.request.GET.get("order", "-created_at")

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["total_tasks"] = Task.objects.all().count()
        context["total_projects"] = Project.objects.all().count()
        return context


# api ?


def update_task(request, id_task):
    try:
        # get task (for id of project, also checks that task exists)
        task = Task.objects.get(id_task=id_task)

        # call manage.py updatebbdb --single_task --id_task 123465 --id_project 123465
        management.call_command(
            "updatebbdb",
            "--single_task",
            id_task=task.id_task,
            id_project=task.project.id_project,
        )

        # get updated task
        task = Task.objects.get(id_task=id_task)

        # get new html code from single task
        html = render_to_string("bugboard/task.html", {"task": task})

        # return task
        data = {
            "message": "Task " + str(id_task) + " was successfully updated!",
            "task": html,
        }
    except Exception as e:
        data = {
            "error": "An unexpected error occured during update of task "
            + str(id_task)
            + ": "
            + str(e)
            + "\n"
            + traceback.format_exc()
        }

    return JsonResponse(data)

bugboard/templates/bugboard/base.html
{% load static %}

{% block content %}
  <!DOCTYPE html>
  <html lang="en">

    <head>
      <meta charset="utf-8">
      <meta http-equiv="X-UA-Compatible" content="IE=edge">
      <meta name="viewport" content="width=device-width, initial-scale=1">
      <title>Welcome to the bugboard</title>
      <link rel="icon" type="image/png" href="{% static 'bugboard/favicon.png' %}" />
      <link href="{% static 'bugboard/bootstrap.min.css' %}" rel="stylesheet">
      <link href="{% static 'bugboard/design.css' %}" rel="stylesheet">
    </head>

    <body>

      <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
          <div class="row">
            <div class="col">
              <a class="navbar-brand" href="/bugboard/"><img class="title"
                                                             src="{% static 'bugboard/title.png' %}" /></a>
              is displaying <b>{{ task_list|length }}</b> tasks
              <div class="alert alert-warning float-right" role="alert">
                <b>{{ total_tasks }}</b> open tasks in
                <b>{{ total_projects }}</b> projects
              </div>
            </div>
          </div>
        </div>
      </nav>

      <div id="hackish-way-of-detecting-sticky-in-js"></div>

      <div class="container-fluid">
        <nav id="menu" class="m-3">
          <div class="btn-group" role="group">
            <a href="/unnassigned/" data-link="/unnassigned/" class="btn btn-outline-secondary">Unnassigned</a>
            <a href="/commented/" data-link="/commented/" class="btn btn-outline-secondary">Last commented</a>
            <a href="/created/" data-link="/created/" class="btn btn-outline-secondary">Last created</a>

            {% for user in BUGBOARD_USER_LIST %}
              <a href="/user/?id={{ user.id }}" data-idname="{{ user.id }}" class="btn btn-outline-secondary" data-placement="bottom" data-toggle="tooltip" title="{{ user.name }}">
                {% if user.avatar %}
                  <img class="avatar" src="{{ user.avatar }}" alt="{{ user.name }}" />
                {% else %}
                  <img class="avatar" src="{% static 'bugboard/default_member.png' %}" alt="{{ user.name }}" />
                {% endif %}
              </a>
            {% endfor %}
            <a href="/all/" data-link="/all/" class="btn btn-outline-secondary">All</a>
          </div>
          <div id="order-group" class="btn-group ml-3" role="group">
            <a id="order-oldest" data-url="created_at" class="btn btn-outline-secondary">Oldest</a>
            <a id="order-newest" data-url="-created_at" class="btn btn-outline-secondary">Newest</a>
          </div>
          <div id="fixed-infos">
            <div class="btn btn-primary btn-sm disabled">
              <b>{{ task_list|length }}</b> tasks
            </div>
          </nav>

          <div id="mainpanel" class="container-fluid">
            <div class="row mx-n1">
              {% for task in task_list %}
                {% block task %}
                  {% include "bugboard/task.html" %}
                {% endblock %}
              {% endfor %}
            </div>
          </div>

        </div>

    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
        <script src="{% static 'bugboard/jquery.min.js' %}"></script>
        <script src="{% static 'bugboard/bootstrap.bundle.min.js' %}"></script>
        <script src="{% static 'bugboard/scripts.js' %}"></script>
      </body>

    </html>
{% endblock %}

bugboard/templates/bugboard/task.html
<div class="col-md-6 col-xl-4 px-1 mb-3" id="task_{{ task.id_task }}">
    <div class="card card-body">
        <h4 class="card-title"><a target="_blank" href="{{ task.admin_link }}">
            🔗 {{ task.project.name }}
        </a></h4>
        <h6 class="card-subtitle mb-2 text-muted">
            <span class="badge badge-light" data-toggle="tooltip" data-placement="top" title="{{ task.created_at|date:"d/m/Y, H:i:s" }}">
                {{ task.created_at|timesince }}
            </span>
            <!-- get_priority_display -->
            {% if task.priority_id == 1 or task.priority_id == 2 %}
                <span class="badge badge-danger font-size-lg">
                    {{ task.priority }}
                </span>
            {% endif %}
        </h6>
        <blockquote class="blockquote">
            <p class="mb-0 card-text">
                {{ task.description }}
            </p>
            <footer class="blockquote-footer">
                {{ task.requester_email }}
            </footer>
        </blockquote>
        {% if task.comment.all.count > 0 %}
            <hr />
            <div>
                {% for comment in task.comment.all|dictsortreversed:"id_comment" %}
                    {% if forloop.first %}
                        <div class="comment">
                            <p>
                                {{ comment.text }}
                            </p>
                            <p class="blockquote-footer">
                                <img src="{{ comment.member.avatar_url }}" class="avatar" />
                                {{ comment.member.display_name }}
                                <span class="badge badge-light" data-toggle="tooltip" data-placement="top" title="{{ comment.created_at|date:"d/m/Y, H:i:s" }}">
                                    {{ comment.created_at|timesince }}
                                </span>
                            </p>
                        </div>
                        {% if task.comment.all.count > 1 %}
                        <details>
                            <summary>
                                View previous comments
                            </summary>
                        {% endif %}
                    {% else %}
                        <div class="small comment">
                            <p>
                                {{ comment.text }}
                            </p>
                            <p class="blockquote-footer">
                                <img src="{{ comment.member.avatar_url }}" class="avatar" />
                                {{ comment.member.display_name }}
                                <span class="badge badge-light" data-toggle="tooltip" data-placement="top" title="{{ comment.created_at|date:"d/m/Y, H:i:s" }}">
                                    {{ comment.created_at|timesince }}
                                </span>
                            </p>
                        </div>
                    {% endif %}
                    {% endfor %}
                </details>
            </div>
        {% endif %}
        <hr />
        <p class="card-text">
            {% for assignee in task.assignee.all %}
                <span class="badge badge-light font-size-lg assignee_{{ assignee.id_member }}">
                    <img src="{{ assignee.avatar_url }}" class="avatar" /> {{ assignee.email.0 }}{{ assignee.email.1 }}{# only display first 2 letters of email address #}
                </span>
            {% endfor %}
            <span class="badge
            {% if task.status == "feedback" %}
                badge-warning
            {% elif task.status == "done" or task.status == "TRAITE" or task.status == "Terminé" %}
                badge-success
            {% else %}
                badge-light
            {% endif %}
            font-size-lg task-{{ task.status }}">
                {% if task.status %}
                    {{ task.status|title }}
                {% else %}
                    Unknown status
                {% endif %}
            </span>
            <span class="btn btn-outline-primary btn-sm reload" onclick="reload_task({{ task.id_task }})" id="reload_{{ task.id_task }}">🔄</span>
            <span class="idsmall">#{{ task.id_task }}</span>
        </p>
    </div>
</div>